package vn.azteam.tpf.service.dto;

import java.time.Instant;
import java.io.Serializable;
import java.util.List;
import java.util.Objects;

/**
 * A DTO for the TBObjectParameter entity.
 */
public class TBObjectParameterDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    private String name;

    private String unit;

    private String description;

    private Instant createdDate;

    private Instant modifiedDate;

    private Instant deletedDate;

    private Long deletedById;

    private Long createdById;

    private Long modifiedById;

    private Long activityTypeId;

    private Long tbCustomerId;

    private Long tbControlTypeId;

    private String tbControlTypeName;

    private Long tbActivityExtendTypeId;

    private String tbActivityExtendTypeName;

    private String tbActivityExtendTypeExternalTable;

    private String tbActivityExtendTypeObjectType;

    private String tbActivityExtendTypeCondition;

    private String relationTable;

    private String foreignKey;

    private List<TBActivityExtendTypeDropDownDTO> tbActivityExtendTypeDropDownDTOList;

    private Boolean isGuidelineUsing;

    private Boolean isMandatory;

    private String groupName;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Instant getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(Instant createdDate) {
        this.createdDate = createdDate;
    }

    public Instant getModifiedDate() {
        return modifiedDate;
    }

    public void setModifiedDate(Instant modifiedDate) {
        this.modifiedDate = modifiedDate;
    }

    public Instant getDeletedDate() {
        return deletedDate;
    }

    public void setDeletedDate(Instant deletedDate) {
        this.deletedDate = deletedDate;
    }

    public Long getDeletedById() {
        return deletedById;
    }

    public void setDeletedById(Long tBDetailUserId) {
        this.deletedById = tBDetailUserId;
    }

    public Long getCreatedById() {
        return createdById;
    }

    public void setCreatedById(Long tBDetailUserId) {
        this.createdById = tBDetailUserId;
    }

    public Long getModifiedById() {
        return modifiedById;
    }

    public void setModifiedById(Long tBDetailUserId) {
        this.modifiedById = tBDetailUserId;
    }

    public Long getActivityTypeId() {
        return activityTypeId;
    }

    public void setActivityTypeId(Long tBActivityTypeId) {
        this.activityTypeId = tBActivityTypeId;
    }

    public Long getTbCustomerId() {
        return tbCustomerId;
    }

    public void setTbCustomerId(Long tbCustomerId) {
        this.tbCustomerId = tbCustomerId;
    }

    public Long getTbControlTypeId() {
        return tbControlTypeId;
    }

    public void setTbControlTypeId(Long tbControlTypeId) {
        this.tbControlTypeId = tbControlTypeId;
    }

    public Long getTbActivityExtendTypeId() {
        return tbActivityExtendTypeId;
    }

    public void setTbActivityExtendTypeId(Long tbActivityExtendTypeId) {
        this.tbActivityExtendTypeId = tbActivityExtendTypeId;
    }

    public Boolean getIsGuidelineUsing() {
        return isGuidelineUsing;
    }

    public void setIsGuidelineUsing(Boolean isGuidelineUsing) {
        this.isGuidelineUsing = isGuidelineUsing;
    }

    public String getTbActivityExtendTypeName() {
        return tbActivityExtendTypeName;
    }

    public void setTbActivityExtendTypeName(String tbActivityExtendTypeName) {
        this.tbActivityExtendTypeName = tbActivityExtendTypeName;
    }

    public String getTbActivityExtendTypeExternalTable() {
        return tbActivityExtendTypeExternalTable;
    }

    public void setTbActivityExtendTypeExternalTable(String tbActivityExtendTypeExternalTable) {
        this.tbActivityExtendTypeExternalTable = tbActivityExtendTypeExternalTable;
    }

    public String getTbActivityExtendTypeObjectType() {
        return tbActivityExtendTypeObjectType;
    }

    public void setTbActivityExtendTypeObjectType(String tbActivityExtendTypeObjectType) {
        this.tbActivityExtendTypeObjectType = tbActivityExtendTypeObjectType;
    }

    public String getTbActivityExtendTypeCondition() {
        return tbActivityExtendTypeCondition;
    }

    public void setTbActivityExtendTypeCondition(String tbActivityExtendTypeCondition) {
        this.tbActivityExtendTypeCondition = tbActivityExtendTypeCondition;
    }

    public String getRelationTable() {
        return relationTable;
    }

    public void setRelationTable(String relationTable) {
        this.relationTable = relationTable;
    }

    public String getForeignKey() {
        return foreignKey;
    }

    public void setForeignKey(String foreignKey) {
        this.foreignKey = foreignKey;
    }

    public String getTbControlTypeName() {
        return tbControlTypeName;
    }

    public void setTbControlTypeName(String tbControlTypeName) {
        this.tbControlTypeName = tbControlTypeName;
    }

    public Boolean getIsMandatory() {
        return isMandatory;
    }

    public void setIsMandatory(Boolean isMandatory) {
        this.isMandatory = isMandatory;
    }

    public String getGroupName() {
        return groupName;
    }

    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }

    public List<TBActivityExtendTypeDropDownDTO> getTbActivityExtendTypeDropDownDTOList() {
        return tbActivityExtendTypeDropDownDTOList;
    }

    public void setTbActivityExtendTypeDropDownDTOList(List<TBActivityExtendTypeDropDownDTO> tbActivityExtendTypeDropDownDTOList) {
        this.tbActivityExtendTypeDropDownDTOList = tbActivityExtendTypeDropDownDTOList;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }

        TBObjectParameterDTO tBObjectParameterDTO = (TBObjectParameterDTO) o;
        if (tBObjectParameterDTO.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), tBObjectParameterDTO.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "TBObjectParameterDTO{" +
            "id=" + getId() +
            ", name='" + getName() + "'" +
            ", unit='" + getUnit() + "'" +
            ", description='" + getDescription() + "'" +
            ", createdDate='" + getCreatedDate() + "'" +
            ", modifiedDate='" + getModifiedDate() + "'" +
            ", deletedDate='" + getDeletedDate() + "'" +
            ", deletedBy=" + getDeletedById() +
            ", createdBy=" + getCreatedById() +
            ", modifiedBy=" + getModifiedById() +
            ", activityType=" + getActivityTypeId() +
            ", customer=" + getTbCustomerId() +
            "}";
    }
}
